/*============================================================================
//	apci59w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleM59
{
	/// <summary>
	/// Apci59w ̊Tv̐łB
	/// </summary>
	public class Apci59w
	{
		private int mErrWradll = SUCCESS;	// bp[֐G[

		// error code
		public const int	SUCCESS								= 0;	// ُȂiIj
		public const int	ERR_SYSTEM							= 1;	// VXeG[
																		// Windows  GetLastError()
																		// R[Ă
		public const int	ERR_NO_DEVICE						= 2;	// gp\ȃfoCX܂
		public const int	ERR_IN_USE							= 3;	// w̃foCX͎gpł
		public const int	ERR_INVALID_SLOT					= 4;	// Ș_Xbgł
		public const int	ERR_RESOURCE						= 5;	// \[XG[
		public const int	ERR_INVALID_PORT					= 6;	// sȃ|[gv
		public const int	ERR_INVALID_ARGUMENT				= 7;	// sȈv܂
		public const int	INVALID_AXIS						= 50;	// Ȑ䎲v
		public const int	ERR_WRAPDLL							= -1;	// bp[֐G[

		// Misc..
		public const short	SLOT_AUTO							= -1;
		public const int	MAX_SLOTS							= 16;

		// Axis
		public const short	AXIS_1								= 0;
		public const short	AXIS_2								= 1;
		public const short	AXIS_3								= 2;
		public const short	AXIS_4								= 3;

		// I/O Map
		public const short	PORT_DATA1							= 0x00;
		public const short	PORT_DATA2							= 0x01;
		public const short	PORT_DATA3							= 0x02;
		public const short	PORT_DATA4							= 0x03;
		public const short	PORT_COMMAND						= 0x04;
		public const short	PORT_MODE1							= 0x05;
		public const short	PORT_MODE2							= 0x06;
		public const short	PORT_UNIVERSAL_SIGNAL				= 0x07;
		public const short	PORT_DRIVE_STATUS					= 0x04;
		public const short	PORT_END_STATUS						= 0x05;
		public const short	PORT_MECHANICAL_SIGNAL				= 0x06;

		// Commands
		public const byte	RANGE_DATA_WRITE					= 0x00;
		public const byte	RANGE_DATA_READ						= 0x01;
		public const byte	START_STOP_SPEED_DATA_WRITE			= 0x02;
		public const byte	START_STOP_SPEED_DATA_READ			= 0x03;
		public const byte	OBJECT_SPEED_DATA_WRITE				= 0x04;
		public const byte	OBJECT_SPEED_DATA_READ				= 0x05;
		public const byte	RATE1_DATA_WRITE					= 0x06;
		public const byte	RATE1_DATA_READ						= 0x07;
		public const byte	RATE2_DATA_WRITE					= 0x08;
		public const byte	RATE2_DATA_READ						= 0x09;
		public const byte	RATE3_DATA_WRITE					= 0x0a;
		public const byte	RATE3_DATA_READ						= 0x0b;
		public const byte	RATE_CHANGE_POINT_1_2_WRITE			= 0x0c;
		public const byte	RATE_CHANGE_POINT_1_2_READ			= 0x0d;
		public const byte	RATE_CHANGE_POINT_2_3_WRITE			= 0x0e;
		public const byte	RATE_CHANGE_POINT_2_3_READ			= 0x0f;
		public const byte	SLOW_DOWN_REAR_PULSE_WRITE			= 0x10;
		public const byte	SLOW_DOWN_REAR_PULSE_READ			= 0x11;
		public const byte	NOW_SPEED_DATA_READ					= 0x12;
		public const byte	DRIVE_PULSE_COUNTER_READ			= 0x13;
		public const byte	PRESET_PULSE_DATA_OVERRIDE			= 0x14;
		public const byte	PRESET_PULSE_DATA_READ				= 0x15;
		public const byte	DEVIATION_DATA_READ					= 0x16;
		public const byte	INPOSITION_WAIT_MODE1_SET			= 0x17;
		public const byte	INPOSITION_WAIT_MODE2_SET			= 0x18;
		public const byte	INPOSITION_WAIT_MODE_RESET			= 0x19;
		public const byte	ALARM_STOP_ENABLE_MODE_SET			= 0x1a;
		public const byte	ALARM_STOP_ENABLE_MODE_RESET		= 0x1b;
		public const byte	INTERRUPT_OUT_ENABLE_MODE_SET		= 0x1c;
		public const byte	INTERRUPT_OUT_ENABLE_MODE_RESET		= 0x1d;
		public const byte	SLOW_DOWN_STOP						= 0x1e;
		public const byte	EMERGENCY_STOP						= 0x1f;
		public const byte	PLUS_PRESET_PULSE_DRIVE				= 0x20;
		public const byte	MINUS_PRESET_PULSE_DRIVE			= 0x21;
		public const byte	PLUS_CONTINUOUS_DRIVE				= 0x22;
		public const byte	MINUS_CONTINUOUS_DRIVE				= 0x23;
		public const byte	PLUS_SIGNAL_SEARCH1_DRIVE			= 0x24;
		public const byte	MINUS_SIGNAL_SEARCH1_DRIVE			= 0x25;
		public const byte	PLUS_SIGNAL_SEARCH2_DRIVE			= 0x26;
		public const byte	MINUS_SIGNAL_SEARCH2_DRIVE			= 0x27;
		public const byte	INTERNAL_COUNTER_WRITE				= 0x28;
		public const byte	INTERNAL_COUNTER_READ				= 0x29;
		public const byte	INTERNAL_COMPARATE_DATA_WRITE		= 0x2a;
		public const byte	INTERNAL_COMPARATE_DATA_READ		= 0x2b;
		public const byte	EXTERNAL_COUNTER_WRITE				= 0x2c;
		public const byte	EXTERNAL_COUNTER_READ				= 0x2d;
		public const byte	EXTERNAL_COMPARATE_DATA_WRITE		= 0x2e;
		public const byte	EXTERNAL_COMPARATE_DATA_READ		= 0x2f;
		public const byte	INTERNAL_PRE_SCALE_DATA_WRITE		= 0x30;
		public const byte	INTERNAL_PRE_SCALE_DATA_READ		= 0x31;
		public const byte	EXTERNAL_PRE_SCALE_DATA_WRITE		= 0x32;
		public const byte	EXTERNAL_PRE_SCALE_DATA_READ		= 0x33;
		public const byte	CLEAR_SIGNAL_SELECT					= 0x34;
		public const byte	ONE_TIME_CLEAR_REQUEST				= 0x35;
		public const byte	FULL_TIME_CLEAR_REQUEST				= 0x36;
		public const byte	CLEAR_REQUEST_RESET					= 0x37;
		public const byte	REVERSE_COUNT_MODE_SET				= 0x38;
		public const byte	REVERSE_COUNT_MODE_RESET			= 0x39;
		public const byte	NO_OPERATION						= 0x3a;
		public const byte	STRAIGHT_ACCELERATE_MODE_SET		= 0x84;
		public const byte	US_STRAIGHT_ACCELERATE_MODE_SET		= 0x85;
		public const byte	S_CURVE_ACCELERATE_MODE_SET			= 0x86;
		public const byte	US_S_CURVE_ACCELERATE_MODE_SET		= 0x87;
		public const byte	SW1_DATA_WRITE						= 0x88;
		public const byte	SW1_DATA_READ						= 0x89;
		public const byte	SW2_DATA_WRITE						= 0x8a;
		public const byte	SW2_DATA_READ						= 0x8b;
		public const byte	SLOW_DOWN_LIMIT_ENABLE_MODE_SET		= 0x8c;
		public const byte	SLOW_DOWN_LIMIT_ENABLE_MODE_RESET	= 0x8d;
		public const byte	EMERGENCY_LIMIT_ENABLE_MODE_SET		= 0x8e;
		public const byte	EMERGENCY_LIMIT_ENABLE_MODE_RESET	= 0x8f;
		public const byte	INITIAL_CLEAR						= 0x90;

		// resources
		public const int	MAX_MEM								= 9;
		public const int	MAX_IO								= 20;
		public const int	MAX_IRQ								= 7;
		public const int	MAX_DMA								= 7;
		public const int	MAX_RSV								= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}

		// API
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetVersion( int* pdwDllVersion, int* pdwDrvVersion );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59Create( short* pwLogSlot );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59Close( short wLogSlot );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59GetResource(short wLogSlot,ref Resource pres );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59InPort( short wLogSlot, short wAxis ,short wPort, byte* pbData );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59OutPort( short wLogSlot, short wAxis ,short wPort, byte bData );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetDriveStatus( short wLogSlot, short wAxis, byte* pbStatus );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetEndStatus( short wLogSlot, short wAxis, byte* pbStatus );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetMechanicalSignal( short wLogSlot, short wAxis, byte* pbSignal );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetUniversalSignal( short wLogSlot, short wAxis, byte* pbSignal );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59Mode1Write( short wLogSlot, short wAxis, byte bMode );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59Mode2Write( short wLogSlot, short wAxis, byte bMode );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59UniversalSignalWrite( short wLogSlot, short wAxis, byte bSignal );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59DataHalfRead( short wLogSlot, short wAxis, byte bCmd, short* pwData );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59DataFullRead( short wLogSlot, short wAxis, byte bCmd, int* pdwData );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59CommandWrite( short wLogSlot, short wAxis, byte bCmd );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59DataHalfWrite( short wLogSlot, short wAxis, byte bCmd, short wData );
		[DllImport("apci59.dll")]
		public extern static        bool Apci59DataFullWrite( short wLogSlot, short wAxis, byte bCmd, int dwData );
		[DllImport("apci59.dll")]
		public extern static unsafe bool Apci59GetSwitchValue( short wLogSlot, int* pdwSwitchValue );
		[DllImport("apci59.dll")]
		public extern static        int  Apci59GetLastError( short wLogSlot );

		public Apci59w()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		//===================================================================
		//   		o[Wԍ擾
		//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
		//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetVersion( int* pdwDllVersion, int* pdwDrvVersion )
		{
			try
			{
				return Apci59GetVersion(pdwDllVersion,pdwDrvVersion);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		foCX̎gp錾
		//   		pwLogSlot		foCXi[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool Create( short* pwLogSlot )
		{
			try
			{
				return Apci59Create(pwLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		foCX̉
		//   		wLogSlot		foCX
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool Close( short wLogSlot )
		{
			try
			{
				return Apci59Close(wLogSlot);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		\[X擾
		//   		wLogSlot		foCX
		//				pres			\[Xi[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool GetResource( short wLogSlot, ref Resource pres )
		{
			try
			{
				return Apci59GetResource(wLogSlot,ref pres);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		ǂݍݎs
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				wPort			Ώۃ|[gԍ
		//				pbData			ǂݍ񂾃f[^i[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool InPort( short wLogSlot, short wAxis ,short wPort, byte* pbData )
		{
			try
			{
				return Apci59InPort(wLogSlot,wAxis,wPort,pbData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		ݎs
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				wPort			Ώۃ|[gԍ
		//				bData			ޒl
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool OutPort( short wLogSlot, short wAxis ,short wPort, byte bData )
		{
			try
			{
				return Apci59OutPort(wLogSlot,wAxis,wPort,bData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		hCuXe[^X擾
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				pbStatus		i[̈ւ̃|C^	
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetDriveStatus( short wLogSlot, short wAxis, byte* pbStatus )
		{
			try
			{
				return Apci59GetDriveStatus(wLogSlot,wAxis,pbStatus);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		GhXe[^X擾
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				pbStatus		i[̈ւ̃|C^	
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetEndStatus( short wLogSlot, short wAxis, byte* pbStatus )
		{
			try
			{
				return Apci59GetEndStatus(wLogSlot,wAxis,pbStatus);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		JjJVOi擾
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				pbSignal		i[̈ւ̃|C^	
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetMechanicalSignal( short wLogSlot, short wAxis, byte* pbSignal )
		{
			try
			{
				return Apci59GetMechanicalSignal(wLogSlot,wAxis,pbSignal);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		jo[TVOi擾
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				pbSignal		i[̈ւ̃|C^	
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetUniversalSignal( short wLogSlot, short wAxis, byte* pbSignal )
		{
			try
			{
				return Apci59GetUniversalSignal(wLogSlot,wAxis,pbSignal);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		[hP
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bMode			ރf[^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool Mode1Write( short wLogSlot, short wAxis, byte bMode )
		{
			try
			{
				return Apci59Mode1Write(wLogSlot,wAxis,bMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		[hQ
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bMode			ރf[^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool Mode2Write( short wLogSlot, short wAxis, byte bMode )
		{
			try
			{
				return Apci59Mode2Write(wLogSlot,wAxis,bMode);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		jo[TVOi
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bSignal			ރf[^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool UniversalSignalWrite( short wLogSlot, short wAxis, byte bSignal )
		{
			try
			{
				return Apci59UniversalSignalWrite(wLogSlot,wAxis,bSignal);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		QoCgf[^ǂݍ
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bCmd			ǂݍݎɎsR}h
		//				pwData			ǂݍ񂾃f[^i[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool DataHalfRead( short wLogSlot, short wAxis, byte bCmd, short* pwData )
		{
			try
			{
				return Apci59DataHalfRead(wLogSlot,wAxis,bCmd,pwData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		SoCgf[^ǂݍ
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bCmd			ǂݍݎɎsR}h
		//				pdwData			ǂݍ񂾃f[^i[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe  bool DataFullRead( short wLogSlot, short wAxis, byte bCmd, int* pdwData )
		{
			try
			{
				return Apci59DataFullRead(wLogSlot,wAxis,bCmd,pdwData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		R}h
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bCmd			R}h
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool CommandWrite( short wLogSlot, short wAxis, byte bCmd )
		{
			try
			{
				return Apci59CommandWrite(wLogSlot,wAxis,bCmd);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		QoCgf[^
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bCmd			ݎɎsR}h
		//				wData			ރf[^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool DataHalfWrite( short wLogSlot, short wAxis, byte bCmd, short wData )
		{
			try
			{
				return Apci59DataHalfWrite(wLogSlot,wAxis,bCmd,wData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		SoCgf[^
		//   		wLogSlot		foCX
		//				wAxis			Ώې䎲
		//				bCmd			ݎɎsR}h
		//				dwData			ރf[^
		// ߂l		true	
		//				false	s
		//===================================================================
		public bool DataFullWrite( short wLogSlot, short wAxis, byte bCmd, int dwData )
		{
			try
			{
				return Apci59DataFullWrite(wLogSlot,wAxis,bCmd,dwData);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		armXCb`̒lǂݍ
		//   		wLogSlot		foCX
		//				pdwSwitchValue	XCb`̒li[̈ւ̃|C^
		// ߂l		true	
		//				false	s
		//===================================================================
		public unsafe bool GetSwitchValue( short wLogSlot, int* pdwSwitchValue )
		{
			try
			{
				return Apci59GetSwitchValue(wLogSlot,pdwSwitchValue);
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return false;
			}
		}
		//===================================================================
		//   		G[R[h擾
		//   		wLogSlot		foCX
		// ߂l		G[R[h
		//===================================================================
		public int GetLastError( short wLogSlot )
		{
			try
			{
				if (mErrWradll == ERR_WRAPDLL)	// bp[֐G[Ȃ
				{
					mErrWradll = SUCCESS;		// NA
					return ERR_WRAPDLL;
				} 
				else 
				{
					return Apci59GetLastError(wLogSlot);
				}
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message, "aPCI-M59 Error", 
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;		// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
	}
}
