#ifndef _APCI59_H_
#define _APCI59_H_

#ifdef __cplusplus
extern "C" {
#endif

// resources
#define APCI59_MAX_MEM				9
#define APCI59_MAX_IO				20
#define APCI59_MAX_IRQ				7
#define APCI59_MAX_DMA				7

typedef struct {
    DWORD   dwNumMemWindows;							// Not used
    DWORD   dwMemBase       [APCI59_MAX_MEM];			// Not used
    DWORD   dwMemLength     [APCI59_MAX_MEM];			// Not used
    DWORD   dwMemAttrib     [APCI59_MAX_MEM];			// Not used
    DWORD   dwNumIOPorts;								// Num IO ports
    DWORD   dwIOPortBase    [APCI59_MAX_IO];			// I/O port base
    DWORD   dwIOPortLength  [APCI59_MAX_IO];			// I/O port length
    DWORD   dwNumIRQs;									// NumIRQs
    DWORD   dwIRQRegisters  [APCI59_MAX_IRQ];			// IRQ Registers
    DWORD   dwIRQAttrib     [APCI59_MAX_IRQ];			// IRQ Attrib
	DWORD	dwNumDMAs;									// Not used
    DWORD   dwDMALst        [APCI59_MAX_DMA];			// Not used
    DWORD   dwDMAAttrib     [APCI59_MAX_DMA];			// Not used
    DWORD   dwReserved1     [3];						// Not used
} APCI59RESOURCE, *PAPCI59R;

// control buffer
typedef struct {
	DWORD	p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15;
} APISG;

// error code
#define APCI59_SUCCESS								0	// ُȂiIj
#define APCI59_ERR_SYSTEM							1	// VXeG[
														// Windows  GetLastError()
														// R[Ă
#define APCI59_ERR_NO_DEVICE						2	// gp\ȃfoCX܂
#define APCI59_ERR_IN_USE							3	// w̃foCX͎gpł
#define APCI59_ERR_INVALID_SLOT						4	// Ș_Xbgł
#define APCI59_ERR_RESOURCE							5	// \[XG[
#define APCI59_ERR_INVALID_PORT						6	// sȃ|[gv
#define APCI59_ERR_INVALID_ARGUMENT					7	// sȈv܂
#define APCI59_ERR_INVALID_AXIS						50	// Ȑ䎲v

// Misc..
#define APCI59_SLOT_AUTO							((WORD)~0U)
#define APCI59_MAX_SLOTS							16

// Axis
#define APCI59_AXIS_1								0
#define APCI59_AXIS_2								1
#define APCI59_AXIS_3								2
#define APCI59_AXIS_4								3

// I/O Map
#define APCI59_PORT_DATA1							0x00
#define APCI59_PORT_DATA2							0x01
#define APCI59_PORT_DATA3							0x02
#define APCI59_PORT_DATA4							0x03
#define APCI59_PORT_COMMAND							0x04
#define APCI59_PORT_MODE1							0x05
#define APCI59_PORT_MODE2							0x06
#define APCI59_PORT_UNIVERSAL_SIGNAL				0x07
#define APCI59_PORT_DRIVE_STATUS					0x04
#define APCI59_PORT_END_STATUS						0x05
#define APCI59_PORT_MECHANICAL_SIGNAL				0x06

// Commands
#define APCI59_RANGE_DATA_WRITE						0x00
#define APCI59_RANGE_DATA_READ						0x01
#define APCI59_START_STOP_SPEED_DATA_WRITE			0x02
#define APCI59_START_STOP_SPEED_DATA_READ			0x03
#define APCI59_OBJECT_SPEED_DATA_WRITE				0x04
#define APCI59_OBJECT_SPEED_DATA_READ				0x05
#define APCI59_RATE1_DATA_WRITE						0x06
#define APCI59_RATE1_DATA_READ						0x07
#define APCI59_RATE2_DATA_WRITE						0x08
#define APCI59_RATE2_DATA_READ						0x09
#define APCI59_RATE3_DATA_WRITE						0x0a
#define APCI59_RATE3_DATA_READ						0x0b
#define APCI59_RATE_CHANGE_POINT_1_2_WRITE			0x0c
#define APCI59_RATE_CHANGE_POINT_1_2_READ			0x0d
#define APCI59_RATE_CHANGE_POINT_2_3_WRITE			0x0e
#define APCI59_RATE_CHANGE_POINT_2_3_READ			0x0f
#define APCI59_SLOW_DOWN_REAR_PULSE_WRITE			0x10
#define APCI59_SLOW_DOWN_REAR_PULSE_READ			0x11
#define APCI59_NOW_SPEED_DATA_READ					0x12
#define APCI59_DRIVE_PULSE_COUNTER_READ				0x13
#define APCI59_PRESET_PULSE_DATA_OVERRIDE			0x14
#define APCI59_PRESET_PULSE_DATA_READ				0x15
#define APCI59_DEVIATION_DATA_READ					0x16
#define APCI59_INPOSITION_WAIT_MODE1_SET			0x17
#define APCI59_INPOSITION_WAIT_MODE2_SET			0x18
#define APCI59_INPOSITION_WAIT_MODE_RESET			0x19
#define APCI59_ALARM_STOP_ENABLE_MODE_SET			0x1a
#define APCI59_ALARM_STOP_ENABLE_MODE_RESET			0x1b
#define APCI59_INTERRUPT_OUT_ENABLE_MODE_SET		0x1c
#define APCI59_INTERRUPT_OUT_ENABLE_MODE_RESET		0x1d
#define APCI59_SLOW_DOWN_STOP						0x1e
#define APCI59_EMERGENCY_STOP						0x1f
#define APCI59_PLUS_PRESET_PULSE_DRIVE				0x20
#define APCI59_MINUS_PRESET_PULSE_DRIVE				0x21
#define APCI59_PLUS_CONTINUOUS_DRIVE				0x22
#define APCI59_MINUS_CONTINUOUS_DRIVE				0x23
#define APCI59_PLUS_SIGNAL_SEARCH1_DRIVE			0x24
#define APCI59_MINUS_SIGNAL_SEARCH1_DRIVE			0x25
#define APCI59_PLUS_SIGNAL_SEARCH2_DRIVE			0x26
#define APCI59_MINUS_SIGNAL_SEARCH2_DRIVE			0x27
#define APCI59_INTERNAL_COUNTER_WRITE				0x28
#define APCI59_INTERNAL_COUNTER_READ				0x29
#define APCI59_INTERNAL_COMPARATE_DATA_WRITE		0x2a
#define APCI59_INTERNAL_COMPARATE_DATA_READ			0x2b
#define APCI59_EXTERNAL_COUNTER_WRITE				0x2c
#define APCI59_EXTERNAL_COUNTER_READ				0x2d
#define APCI59_EXTERNAL_COMPARATE_DATA_WRITE		0x2e
#define APCI59_EXTERNAL_COMPARATE_DATA_READ			0x2f
#define APCI59_INTERNAL_PRE_SCALE_DATA_WRITE		0x30
#define APCI59_INTERNAL_PRE_SCALE_DATA_READ			0x31
#define APCI59_EXTERNAL_PRE_SCALE_DATA_WRITE		0x32
#define APCI59_EXTERNAL_PRE_SCALE_DATA_READ			0x33
#define APCI59_CLEAR_SIGNAL_SELECT					0x34
#define APCI59_ONE_TIME_CLEAR_REQUEST				0x35
#define APCI59_FULL_TIME_CLEAR_REQUEST				0x36
#define APCI59_CLEAR_REQUEST_RESET					0x37
#define APCI59_REVERSE_COUNT_MODE_SET				0x38
#define APCI59_REVERSE_COUNT_MODE_RESET				0x39
#define APCI59_NO_OPERATION							0x3a
#define APCI59_STRAIGHT_ACCELERATE_MODE_SET			0x84
#define APCI59_US_STRAIGHT_ACCELERATE_MODE_SET		0x85
#define APCI59_S_CURVE_ACCELERATE_MODE_SET			0x86
#define APCI59_US_S_CURVE_ACCELERATE_MODE_SET		0x87
#define APCI59_SW1_DATA_WRITE						0x88
#define APCI59_SW1_DATA_READ						0x89
#define APCI59_SW2_DATA_WRITE						0x8a
#define APCI59_SW2_DATA_READ						0x8b
#define APCI59_SLOW_DOWN_LIMIT_ENABLE_MODE_SET		0x8c
#define APCI59_SLOW_DOWN_LIMIT_ENABLE_MODE_RESET	0x8d
#define APCI59_EMERGENCY_LIMIT_ENABLE_MODE_SET		0x8e
#define APCI59_EMERGENCY_LIMIT_ENABLE_MODE_RESET	0x8f
#define APCI59_INITIAL_CLEAR						0x90

#ifdef __cplusplus
}
#endif
#endif
