//===================================================================
// Apci59w.c
//-------------------------------------------------------------------
// aPCI-M59
// Copyright (C) ADTEK SYSTEM SCIENCE Co.,Ltd.
//===================================================================
#include <windows.h>
#include <tchar.h>
#include "Apci59w.h"

// -- X^eBbN֐ & X^eBbNϐi萔j
static BOOL Apci59wGetDllExportFunc( VOID );
static HANDLE hDLL = NULL;
// -- GNX|[g֐AhX̊i[pϐ
static FARPROC pApci59GetVersion;
static FARPROC pApci59Create;
static FARPROC pApci59Close;
static FARPROC pApci59GetResource;
static FARPROC pApci59InPort;
static FARPROC pApci59OutPort;
static FARPROC pApci59GetLastError;
static FARPROC pApci59GetDriveStatus;
static FARPROC pApci59GetEndStatus;
static FARPROC pApci59GetMechanicalSignal;
static FARPROC pApci59GetUniversalSignal;
static FARPROC pApci59Mode1Write;
static FARPROC pApci59Mode2Write;
static FARPROC pApci59UniversalSignalWrite;
static FARPROC pApci59DataHalfRead;
static FARPROC pApci59DataFullRead;
static FARPROC pApci59CommandWrite;
static FARPROC pApci59DataHalfWrite;
static FARPROC pApci59DataFullWrite;
static FARPROC pApci59GetSwitchValue;

//===================================================================
//   		DLL [h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDllOpen( VOID )
{
	if ( hDLL != NULL ) return FALSE;
	hDLL = (HMODULE)LoadLibrary(APCI59_DLL_NAME);
	if ( hDLL == NULL ) return FALSE;
	if ( Apci59wGetDllExportFunc() == FALSE ) {
		Apci59wDllClose();
		return FALSE;
	}
	return TRUE;
}
//===================================================================
//   		DLL A[h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDllClose( VOID )
{
	if ( hDLL == NULL ) return FALSE;
	if ( FreeLibrary(hDLL) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//===================================================================
//   		o[Wԍ擾
//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetVersion)(pdwDllVersion,pdwDrvVersion);
}
//===================================================================
//   		foCX̎gp錾
//   		pwLogSlot		foCXi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wCreate( PWORD pwLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59Create)(pwLogSlot);
}
//===================================================================
//   		foCX̉
//   		wLogSlot		foCX
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wClose(WORD wLogSlot)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59Close)(wLogSlot);
}
//===================================================================
//   		\[X擾
//   		wLogSlot		foCX
//				pres			\[Xi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetResource(WORD wLogSlot, PAPCI59R pres)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetResource)(wLogSlot,pres);
}
//===================================================================
//   		ǂݍݎs
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				wPort			Ώۃ|[gԍ
//				pbData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wInPort( WORD wLogSlot, WORD wAxis ,WORD wPort, PBYTE pbData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59InPort)(wLogSlot,wAxis,wPort,pbData);
}
//===================================================================
//   		ݎs
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				wPort			Ώۃ|[gԍ
//				bData			ޒl
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wOutPort( WORD wLogSlot, WORD wAxis ,WORD wPort, BYTE bData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59OutPort)(wLogSlot,wAxis,wPort,bData);
}
//===================================================================
//   		hCuXe[^X擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbStatus		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetDriveStatus( WORD wLogSlot, WORD wAxis, PBYTE pbStatus)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetDriveStatus)(wLogSlot,wAxis,pbStatus);
}
//===================================================================
//   		GhXe[^X擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbStatus		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetEndStatus( WORD wLogSlot, WORD wAxis, PBYTE pbStatus)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetEndStatus)(wLogSlot,wAxis,pbStatus);
}
//===================================================================
//   		JjJVOi擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbSignal		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetMechanicalSignal( WORD wLogSlot, WORD wAxis, PBYTE pbSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetMechanicalSignal)(wLogSlot,wAxis,pbSignal);
}
//===================================================================
//   		jo[TVOi擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbSignal		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetUniversalSignal( WORD wLogSlot, WORD wAxis, PBYTE pbSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetUniversalSignal)(wLogSlot,wAxis,pbSignal);
}
//===================================================================
//   		[hP
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bMode			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wMode1Write( WORD wLogSlot, WORD wAxis, BYTE bMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59Mode1Write)(wLogSlot,wAxis,bMode);
}
//===================================================================
//   		[hQ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bMode			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wMode2Write( WORD wLogSlot, WORD wAxis, BYTE bMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59Mode2Write)(wLogSlot,wAxis,bMode);
}
//===================================================================
//   		jo[TVOi
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bSignal			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wUniversalSignalWrite( WORD wLogSlot, WORD wAxis, BYTE bSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59UniversalSignalWrite)(wLogSlot,wAxis,bSignal);
}
//===================================================================
//   		QoCgf[^ǂݍ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ǂݍݎɎsR}h
//				pwData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDataHalfRead( WORD wLogSlot, WORD wAxis, BYTE bCmd, PWORD pwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59DataHalfRead)(wLogSlot,wAxis,bCmd,pwData);
}
//===================================================================
//   		SoCgf[^ǂݍ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ǂݍݎɎsR}h
//				pdwData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDataFullRead( WORD wLogSlot, WORD wAxis, BYTE bCmd, PDWORD pdwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59DataFullRead)(wLogSlot,wAxis,bCmd,pdwData);
}
//===================================================================
//   		R}h
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			R}h
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wCommandWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59CommandWrite)(wLogSlot,wAxis,bCmd);
}
//===================================================================
//   		QoCgf[^
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ݎɎsR}h
//				wData			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDataHalfWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd, WORD wData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59DataHalfWrite)(wLogSlot,wAxis,bCmd,wData);
}
//===================================================================
//   		SoCgf[^
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ݎɎsR}h
//				dwData			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wDataFullWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd, DWORD dwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59DataFullWrite)(wLogSlot,wAxis,bCmd,dwData);
}
//===================================================================
//   		armXCb`̒lǂݍ
//   		wLogSlot		foCX
//				pdwSwitchValue	XCb`̒li[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Apci59wGetSwitchValue( WORD wLogSlot, PDWORD pdwSwitchValue )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pApci59GetSwitchValue)(wLogSlot,pdwSwitchValue);
}
//===================================================================
//   		G[R[h擾
//   		wLogSlot		foCX
// ߂l		G[R[h
//===================================================================
DWORD Apci59wGetLastError( WORD wLogSlot )
{
	if ( hDLL == NULL ) return APCI59_ERR_WRAPDLL;
	return (*pApci59GetLastError)(wLogSlot);
}
//-------------------------------------------------------------------
//   		DLLGNX|[g֐AhX̎擾
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//-------------------------------------------------------------------
static BOOL Apci59wGetDllExportFunc( VOID )
{
	pApci59GetVersion = GetProcAddress( hDLL, "Apci59GetVersion");
	if ( pApci59GetVersion == NULL ) return FALSE;
	pApci59Create = GetProcAddress( hDLL, "Apci59Create");
	if ( pApci59Create == NULL ) return FALSE;
	pApci59Close = GetProcAddress( hDLL, "Apci59Close");
	if ( pApci59Close == NULL ) return FALSE;
	pApci59GetResource = GetProcAddress( hDLL, "Apci59GetResource");
	if ( pApci59GetResource == NULL ) return FALSE;
	pApci59InPort = GetProcAddress( hDLL, "Apci59InPort");
	if ( pApci59InPort == NULL ) return FALSE;
	pApci59OutPort = GetProcAddress( hDLL, "Apci59OutPort");
	if ( pApci59OutPort == NULL ) return FALSE;
	pApci59GetLastError = GetProcAddress( hDLL, "Apci59GetLastError");
	if ( pApci59GetLastError == NULL ) return FALSE;
	pApci59GetDriveStatus = GetProcAddress( hDLL, "Apci59GetDriveStatus");
	if ( pApci59GetDriveStatus == NULL ) return FALSE;
	pApci59GetEndStatus = GetProcAddress( hDLL, "Apci59GetEndStatus");
	if ( pApci59GetEndStatus == NULL ) return FALSE;
	pApci59GetMechanicalSignal = GetProcAddress( hDLL, "Apci59GetMechanicalSignal");
	if ( pApci59GetMechanicalSignal == NULL ) return FALSE;
	pApci59GetUniversalSignal = GetProcAddress( hDLL, "Apci59GetUniversalSignal");
	if ( pApci59GetUniversalSignal == NULL ) return FALSE;
	pApci59Mode1Write = GetProcAddress( hDLL, "Apci59Mode1Write");
	if ( pApci59Mode1Write == NULL ) return FALSE;
	pApci59Mode2Write = GetProcAddress( hDLL, "Apci59Mode2Write");
	if ( pApci59Mode2Write == NULL ) return FALSE;
	pApci59UniversalSignalWrite = GetProcAddress( hDLL, "Apci59UniversalSignalWrite");
	if ( pApci59UniversalSignalWrite == NULL ) return FALSE;
	pApci59DataHalfRead = GetProcAddress( hDLL, "Apci59DataHalfRead");
	if ( pApci59DataHalfRead == NULL ) return FALSE;
	pApci59DataFullRead = GetProcAddress( hDLL, "Apci59DataFullRead");
	if ( pApci59DataFullRead == NULL ) return FALSE;
	pApci59CommandWrite = GetProcAddress( hDLL, "Apci59CommandWrite");
	if ( pApci59CommandWrite == NULL ) return FALSE;
	pApci59DataHalfWrite = GetProcAddress( hDLL, "Apci59DataHalfWrite");
	if ( pApci59DataHalfWrite == NULL ) return FALSE;
	pApci59DataFullWrite = GetProcAddress( hDLL, "Apci59DataFullWrite");
	if ( pApci59DataFullWrite == NULL ) return FALSE;
	pApci59GetSwitchValue = GetProcAddress( hDLL, "Apci59GetSwitchValue");
	if ( pApci59GetSwitchValue == NULL ) return FALSE;

	return TRUE;	// SẴAhX擾
}

